"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isString = isString;
exports.snakeToCamel = snakeToCamel;
exports.camelToKebab = camelToKebab;
exports.upperFirstLetter = upperFirstLetter;
exports.kebabToCamel = kebabToCamel;
exports.capitalizeFirstChar = capitalizeFirstChar;
function isString(value) {
    return typeof value === 'string' || value instanceof String;
}
function snakeToCamel(str) {
    if (!str.match(/[\s_-]/g)) {
        return str;
    }
    return str.replace(/([-_][a-z])/g, (group) => group.toUpperCase().replace('-', '').replace('_', ''));
}
function camelToKebab(string) {
    return string
        .replace(/((?<=[a-z\d])[A-Z]|(?<=[A-Z\d])[A-Z](?=[a-z]))/g, '-$1')
        .toLowerCase();
}
function upperFirstLetter(string) {
    return (string.charAt(0).toUpperCase() + string.slice(1));
}
function kebabToCamel(str) {
    return str
        .split('-')
        .map((i) => i.charAt(0).toUpperCase() + i.substring(1))
        .join('');
}
function capitalizeFirstChar(str) {
    return str
        .split('-')
        .map((i) => i.charAt(0).toUpperCase() + i.substring(1))
        .join('');
}
//# sourceMappingURL=string-utils.js.map