"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeormServiceFactory = TypeormServiceFactory;
const constants_1 = require("../constants");
const helper_1 = require("../helper");
const service_1 = require("../service");
const service_2 = require("../mixin/service");
function guardMethodsServiceName(methodsService, key) {
    if (!(key in methodsService))
        throw new Error(`${key} is not methode of MethodsService`);
}
function TypeormServiceFactory(entity) {
    const entityName = (0, helper_1.getEntityName)(entity);
    return {
        provide: constants_1.TYPEORM_SERVICE,
        inject: [
            {
                token: constants_1.CURRENT_ENTITY_REPOSITORY,
                optional: false,
            },
            {
                token: constants_1.CONTROL_OPTIONS_TOKEN,
                optional: false,
            },
            service_1.TypeormUtilsService,
            service_2.TransformDataService,
        ],
        useFactory: (repository, config, typeormUtilsService, transformDataService) => {
            const typeOrmObject = {
                repository,
                config,
                typeormUtilsService,
                transformDataService,
            };
            const bindMethods = helper_1.ObjectTyped.entries(helper_1.MethodsService).reduce((acum, [key, val]) => ({
                ...acum,
                [key]: val.bind(typeOrmObject),
            }), {});
            const target = {};
            return new Proxy(target, {
                get(target, p, receiver) {
                    try {
                        guardMethodsServiceName(bindMethods, p);
                        return bindMethods[p];
                    }
                    catch (e) {
                        return undefined;
                    }
                },
            });
        },
    };
}
//# sourceMappingURL=typeorm-service.factory.js.map