import { Entity } from '../types';
import { FactoryProvider, ValueProvider } from '@nestjs/common';
import { ZodInputQuerySchema, ZodQuerySchema, ZodInputPostSchema, ZodInputPatchSchema, ZodInputPostRelationshipSchema as ZodInputPostRelationshipSchemaType, ZodInputPatchRelationshipSchema as ZodInputPatchRelationshipSchemaType } from '../helper/zod';
export declare function ZodInputQuerySchema<E extends Entity>(entity: E): FactoryProvider<ZodInputQuerySchema<E>>;
export declare function ZodQuerySchema<E extends Entity>(entity: E): FactoryProvider<ZodQuerySchema<E>>;
export declare function ZodInputPostSchema<E extends Entity>(entity: E): FactoryProvider<ZodInputPostSchema<E>>;
export declare function ZodInputPatchSchema<E extends Entity>(entity: E): FactoryProvider<ZodInputPatchSchema<E>>;
export declare const ZodInputPostRelationshipSchema: ValueProvider<ZodInputPostRelationshipSchemaType>;
export declare const ZodInputPatchRelationshipSchema: ValueProvider<ZodInputPatchRelationshipSchemaType>;
