import { EntityMetadata } from 'typeorm';
import { BadRequestException, ConflictException, NotAcceptableException } from '@nestjs/common';
export declare const MysqlError: {
    1364: (entityMetadata: EntityMetadata, errorText: string, detail?: string) => BadRequestException;
    1062: (entityMetadata: EntityMetadata, errorText: string, detail?: string) => ConflictException;
    1525: (entityMetadata: EntityMetadata, errorText: string, detail?: string) => BadRequestException;
};
export declare const PostgresError: {
    23502: (entityMetadata: EntityMetadata, errorText: string, detail?: string) => BadRequestException;
    23505: (entityMetadata: EntityMetadata, errorText: string, detail?: string) => ConflictException;
    "22P02": (entityMetadata: EntityMetadata, errorText: string, detail?: string) => BadRequestException;
    22007: (entityMetadata: EntityMetadata, errorText: string, detail?: string) => BadRequestException;
    22003: (entityMetadata: EntityMetadata, errorText: string, detail?: string) => BadRequestException;
    23503: (entityMetadata: EntityMetadata, errorText: string, detail?: string) => NotAcceptableException;
};
export type PostgresErrorCode = keyof typeof PostgresError;
export type MysqlErrorCode = keyof typeof MysqlError;
