"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.patchRelationship = patchRelationship;
const get_relationship_1 = require("../get-relationship/get-relationship");
async function patchRelationship(id, rel, input) {
    const idsResult = await this.typeormUtilsService.validateRelationInputData(rel, input);
    const patchBuilder = this.repository
        .createQueryBuilder()
        .relation(rel.toString())
        .of(id);
    if (Array.isArray(idsResult)) {
        const data = await get_relationship_1.getRelationship.call(this, id, rel);
        const idsToDelete = Array.isArray(data.data)
            ? data.data.map((i) => i.id)
            : [];
        await patchBuilder.addAndRemove(idsResult, idsToDelete);
    }
    else {
        await patchBuilder.set(idsResult);
    }
    return get_relationship_1.getRelationship.call(this, id, rel);
}
//# sourceMappingURL=patch-relationship.js.map