"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.postOne = postOne;
async function postOne(inputData) {
    const { attributes, relationships, id } = inputData;
    const idObject = id
        ? { [this.typeormUtilsService.currentPrimaryColumn.toString()]: id }
        : {};
    const attributesObject = {
        ...attributes,
        ...idObject,
    };
    const entityTarget = this.repository.manager.create(this.repository.target, attributesObject);
    const saveData = await this.typeormUtilsService.saveEntityData(entityTarget, relationships);
    const { data, included } = this.transformDataService.transformData(saveData);
    const includeData = included ? { included } : {};
    return {
        meta: {},
        data,
        ...includeData,
    };
}
//# sourceMappingURL=post-one.js.map