"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.postOne = postOne;
const swagger_1 = require("@nestjs/swagger");
const utils_1 = require("../utils");
const utils_2 = require("../utils");
const zod_openapi_1 = require("@anatine/zod-openapi");
const zod_1 = require("../../zod");
const zod_nestjs_1 = require("@anatine/zod-nestjs");
function postOne(controller, repository, binding, config) {
    const entityName = repository.metadata.name;
    const descriptor = Reflect.getOwnPropertyDescriptor(controller, binding.name);
    if (!descriptor)
        throw new Error(`Descriptor for entity controller ${entityName} is empty`);
    const classBodySchemaDto = (0, zod_nestjs_1.createZodDto)((0, zod_openapi_1.extendApi)((0, zod_1.zodInputPostSchema)(repository)));
    Object.defineProperty(classBodySchemaDto, 'name', {
        value: `${entityName}PostOne`,
    });
    (0, swagger_1.ApiExtraModels)(classBodySchemaDto)(controller.constructor);
    (0, swagger_1.ApiOperation)({
        summary: `Create item of resource "${entityName}"`,
        operationId: `${controller.constructor.name}_${binding.name}`,
    })(controller, binding.name, descriptor);
    (0, swagger_1.ApiBody)({
        description: `Json api schema for new "${entityName}" item`,
        schema: (0, zod_openapi_1.generateSchema)((0, zod_1.zodInputPostSchema)(repository)),
        required: true,
    })(controller, binding.name, descriptor);
    (0, swagger_1.ApiResponse)({
        status: 201,
        description: `Item of resource "${entityName}" has been created`,
        schema: (0, utils_1.jsonSchemaResponse)(repository),
    })(controller, binding.name, descriptor);
    (0, swagger_1.ApiResponse)({
        status: 400,
        description: 'Wrong body parameters',
        schema: utils_2.errorSchema,
    })(controller, binding.name, descriptor);
    (0, swagger_1.ApiResponse)({
        status: 422,
        description: 'Unprocessable data',
        schema: utils_2.errorSchema,
    })(controller, binding.name, descriptor);
}
//# sourceMappingURL=post-one.js.map