"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEntityName = exports.nameIt = exports.ObjectTyped = exports.isString = exports.upperFirstLetter = exports.kebabToCamel = exports.snakeToCamel = exports.camelToKebab = void 0;
exports.getProviderName = getProviderName;
exports.entityForClass = entityForClass;
const constants_1 = require("../constants");
const shared_utils_1 = require("../../../shared-utils/src");
var shared_utils_2 = require("../../../shared-utils/src");
Object.defineProperty(exports, "camelToKebab", { enumerable: true, get: function () { return shared_utils_2.camelToKebab; } });
Object.defineProperty(exports, "snakeToCamel", { enumerable: true, get: function () { return shared_utils_2.snakeToCamel; } });
Object.defineProperty(exports, "kebabToCamel", { enumerable: true, get: function () { return shared_utils_2.kebabToCamel; } });
Object.defineProperty(exports, "upperFirstLetter", { enumerable: true, get: function () { return shared_utils_2.upperFirstLetter; } });
Object.defineProperty(exports, "isString", { enumerable: true, get: function () { return shared_utils_2.isString; } });
Object.defineProperty(exports, "ObjectTyped", { enumerable: true, get: function () { return shared_utils_2.ObjectTyped; } });
const nameIt = (name, cls) => ({
    [name]: class extends cls {
        constructor(...arg) {
            super(...arg);
        }
    },
}[name]);
exports.nameIt = nameIt;
const getEntityName = (entity) => {
    if (typeof entity === 'string') {
        return entity;
    }
    if ('name' in entity) {
        return entity['name'];
    }
    if ('constructor' in entity && 'name' in entity.constructor) {
        return entity['constructor']['name'];
    }
    return `${entity}`;
};
exports.getEntityName = getEntityName;
function getProviderName(entity, name) {
    const entityName = (0, exports.getEntityName)(entity);
    return `${(0, shared_utils_1.upperFirstLetter)(entityName)}${name}`;
}
function entityForClass(type) {
    return Reflect.getMetadata(constants_1.JSON_API_DECORATOR_ENTITY, type);
}
//# sourceMappingURL=utils.js.map