import { ZodArray, ZodEffects, ZodObject, ZodOptional, ZodNullable } from 'zod';
import { Entity } from '../../../types';
import { RelationPrimaryColumnType, RelationPropsType, RelationPropsTypeName } from '../../orm';
import { ZodDataSchema } from '../zod-input-post-schema/data';
export type DataArray<S extends string> = ZodArray<ZodDataSchema<S>>;
export type DataItem<E extends boolean> = ZodOptional<E extends true ? DataArray<string> : ZodNullable<ZodDataSchema<string>>>;
export type ShapeRelationships<E extends Entity> = {
    [K in keyof RelationPropsType<E>]: DataItem<RelationPropsType<E>[K]>;
};
export type ZodPatchRelationshipsSchema<E extends Entity> = ZodEffects<ZodObject<ShapeRelationships<E>, 'strict'>>;
export declare const zodPatchRelationshipsSchema: <E extends Entity>(relationArrayProps: RelationPropsType<E>, relationPopsName: RelationPropsTypeName<E>, primaryColumnType: RelationPrimaryColumnType<E>) => ZodPatchRelationshipsSchema<E>;
