import { ZodArray, ZodEffects, ZodObject, ZodOptional } from 'zod';
import { Entity } from '../../../types';
import { ArrayPropsForEntity, RelationPrimaryColumnType, RelationPropsType, RelationPropsTypeName } from '../../orm';
import { ZodDataSchema } from './data';
export type PropsArray<E extends Entity> = Omit<ArrayPropsForEntity<E>, 'target'>;
export type DataArray<S extends string> = ZodArray<ZodDataSchema<S>, 'atleastone'>;
export type DataItem<E extends boolean> = ZodOptional<E extends true ? DataArray<string> : ZodDataSchema<string>>;
export type ShapeRelationships<E extends Entity> = {
    [K in keyof RelationPropsType<E>]: DataItem<RelationPropsType<E>[K]>;
};
export type ZodRelationshipsSchema<E extends Entity> = ZodEffects<ZodObject<ShapeRelationships<E>, 'strict'>>;
export declare const zodRelationshipsSchema: <E extends Entity>(relationArrayProps: RelationPropsType<E>, relationPopsName: RelationPropsTypeName<E>, primaryColumnType: RelationPrimaryColumnType<E>) => ZodRelationshipsSchema<E>;
