"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodRelationshipsSchema = void 0;
const zod_1 = require("zod");
const data_1 = require("./data");
const zod_utils_1 = require("../zod-utils");
const utils_1 = require("../../utils");
const zodRelationshipsSchema = (relationArrayProps, relationPopsName, primaryColumnType) => {
    const shape = utils_1.ObjectTyped.entries(relationArrayProps).reduce((acum, [props, value]) => {
        const typeName = (0, utils_1.camelToKebab)(relationPopsName[props]);
        const primaryType = primaryColumnType[props];
        const zodDataSchemaObject = (0, data_1.zodDataSchema)(typeName, primaryType);
        const dataItem = (value ? zod_1.z.array(zodDataSchemaObject).nonempty() : zodDataSchemaObject).optional();
        return {
            ...acum,
            [props]: zod_1.z.union([
                dataItem,
                zod_1.z
                    .object({ data: dataItem })
                    .strict()
                    .refine((0, zod_utils_1.nonEmptyObject)())
                    .transform((i) => {
                    const { data } = i;
                    return data;
                }),
            ]),
        };
    }, {});
    return zod_1.z.object(shape).strict().refine((0, zod_utils_1.nonEmptyObject)());
};
exports.zodRelationshipsSchema = zodRelationshipsSchema;
//# sourceMappingURL=relationships.js.map