import { ZodEffects, ZodObject, ZodOptional, ZodString, ZodTypeAny } from 'zod';
import { ResultGetField } from '../../orm';
import { Entity } from '../../../types';
export type ZodSelectFieldsInputQuerySchema<E extends Entity> = ZodEffects<ZodObject<ObjectForSelectField<ResultGetField<E>['relations'], ZodString>, 'strict'>>;
export type ZodFilterMap<R extends readonly [string, ...string[]], F extends ZodTypeAny> = {
    [K in R[number]]: ZodOptional<F>;
};
type ObjectForSelectField<R extends readonly [string, ...string[]], K extends ZodTypeAny> = {
    target: ZodOptional<K>;
} & ZodFilterMap<R, K>;
export declare const zodSelectFieldsInputQuerySchema: <E extends Entity>(relationList: ResultGetField<E>["relations"]) => ZodSelectFieldsInputQuerySchema<E>;
export {};
