"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodSelectFieldsInputQuerySchema = void 0;
const zod_1 = require("zod");
const zod_utils_1 = require("../zod-utils");
const objectForSelectField = (relationList) => {
    const relation = relationList.reduce((acum, item) => ({ ...acum, ...{ [item]: zod_1.z.string().optional() } }), {});
    return {
        target: zod_1.z.string().optional(),
        ...relation,
    };
};
const zodSelectFieldsInputQuerySchema = (relationList) => {
    const resultShape = objectForSelectField(relationList);
    return zod_1.z
        .object(resultShape)
        .strict((0, zod_utils_1.getValidationErrorForStrict)(['target', ...relationList], 'Fields'))
        .refine((0, zod_utils_1.nonEmptyObject)(), {
        message: 'Validation error: Need select field for target or relation',
    });
};
exports.zodSelectFieldsInputQuerySchema = zodSelectFieldsInputQuerySchema;
//# sourceMappingURL=select.js.map