"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodPageQuerySchema = void 0;
const zod_1 = require("zod");
const constants_1 = require("../../../constants");
const checkNumber = (a) => {
    if (typeof a === 'string') {
        return parseInt(a, 10);
    }
    else if (typeof a === 'number') {
        return a;
    }
    else {
        return undefined;
    }
};
exports.zodPageQuerySchema = zod_1.z
    .object({
    size: zod_1.z.preprocess(checkNumber, zod_1.z.number().int().min(1).default(constants_1.DEFAULT_PAGE_SIZE)),
    number: zod_1.z.preprocess(checkNumber, zod_1.z.number().int().min(1).default(constants_1.DEFAULT_QUERY_PAGE)),
})
    .strict()
    .default({
    size: constants_1.DEFAULT_PAGE_SIZE,
    number: constants_1.DEFAULT_QUERY_PAGE,
});
//# sourceMappingURL=page.js.map