import { Writeable, ZodArray, ZodEffects, ZodEnum, ZodObject, ZodOptional } from 'zod';
import { Entity } from '../../../types';
import { RelationTree, ResultGetField } from '../../orm';
type ZodField<R extends readonly [string, ...string[]]> = ZodEffects<ZodArray<ZodEnum<Writeable<R>>, 'atleastone'>, [
    Writeable<R>[number],
    ...Writeable<R>[number][]
], [
    Writeable<R>[number],
    ...Writeable<R>[number][]
]>;
type ZodTarget<R extends readonly [string, ...string[]]> = {
    target: ZodOptional<ZodField<R>>;
};
export declare const zodTarget: <R extends readonly [string, ...string[]]>(fields: R) => ZodTarget<R>;
type ZodRelation<E extends Entity> = {
    [K in keyof RelationTree<E>]: ZodOptional<ZodField<RelationTree<E>[K]>>;
};
type ZodResultShape<E extends Entity> = ZodTarget<ResultGetField<E>['field']> & ZodRelation<E>;
export type ZodSelectFields<E extends Entity> = ZodEffects<ZodObject<ZodResultShape<E>, 'strict'>>;
export type ZodSelectFieldsQuerySchema<E extends Entity> = ZodEffects<ZodSelectFields<E>>;
export declare const zodSelectFieldsQuerySchema: <E extends Entity>(fields: ResultGetField<E>["field"], relationList: RelationTree<E>) => ZodSelectFieldsQuerySchema<E>;
export {};
