"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.zodSelectFieldsQuerySchema = exports.zodTarget = void 0;
const zod_1 = require("zod");
const utils_1 = require("../../utils");
const zod_utils_1 = require("../zod-utils");
const zodFields = (fields) => zod_1.z.enum(fields).array().nonempty().refine((0, zod_utils_1.uniqueArray)(), {
    message: 'Field should be unique',
});
const zodTarget = (fields) => ({
    target: zodFields([...fields]).optional(),
});
exports.zodTarget = zodTarget;
const zodSelectFieldsQuerySchema = (fields, relationList) => {
    const target = (0, exports.zodTarget)(fields);
    const relation = utils_1.ObjectTyped.entries(relationList).reduce((acum, [key, val]) => {
        acum[key] = zodFields(val).optional();
        return acum;
    }, {});
    const resultShape = {
        ...target,
        ...relation,
    };
    const zodSelectFields = zod_1.z
        .object(resultShape)
        .strict('Should be only target of relation ');
    // @ts-ignore
    return zodSelectFields.refine((0, zod_utils_1.nonEmptyObject)(), {
        message: 'Validation error: Select target or relation fields',
    });
};
exports.zodSelectFieldsQuerySchema = zodSelectFieldsQuerySchema;
//# sourceMappingURL=select.js.map