"use strict";
var JsonApiNestJsCommonModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonApiNestJsCommonModule = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const typeorm_1 = require("@nestjs/typeorm");
const constants_1 = require("./constants");
const factory_1 = require("./factory");
const service_1 = require("./service");
let JsonApiNestJsCommonModule = JsonApiNestJsCommonModule_1 = class JsonApiNestJsCommonModule {
    static forRoot(options) {
        const optionProvider = {
            provide: constants_1.GLOBAL_MODULE_OPTIONS_TOKEN,
            useValue: options,
        };
        const currentDataSourceProvider = (0, factory_1.CurrentDataSourceProvider)(options.connectionName);
        const typeOrmModule = typeorm_1.TypeOrmModule.forFeature(options.entities, options.connectionName);
        return {
            module: JsonApiNestJsCommonModule_1,
            imports: [typeOrmModule, ...(options.imports || [])],
            providers: [
                ...(options.providers || []),
                optionProvider,
                currentDataSourceProvider,
                service_1.TransformInputService,
                service_1.EntityPropsMapService,
                factory_1.SwaggerBindMethod,
            ],
            exports: [
                ...(options.providers || []),
                typeOrmModule,
                optionProvider,
                currentDataSourceProvider,
                service_1.TransformInputService,
                service_1.EntityPropsMapService,
                factory_1.SwaggerBindMethod,
                ...(options.imports || []),
            ],
        };
    }
};
exports.JsonApiNestJsCommonModule = JsonApiNestJsCommonModule;
exports.JsonApiNestJsCommonModule = JsonApiNestJsCommonModule = JsonApiNestJsCommonModule_1 = tslib_1.__decorate([
    (0, common_1.Module)({})
], JsonApiNestJsCommonModule);
//# sourceMappingURL=json-api-nestjs-common.module.js.map