"use strict";
var JsonApiModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonApiModule = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const constants_1 = require("./constants");
const json_api_nestjs_common_module_1 = require("./json-api-nestjs-common.module");
const constants_2 = require("./constants");
const mixin_1 = require("./mixin");
const atomic_operation_module_1 = require("./modules/atomic-operation/atomic-operation.module");
let JsonApiModule = class JsonApiModule {
    static { JsonApiModule_1 = this; }
    static connectionName = constants_1.DEFAULT_CONNECTION_NAME;
    static forRoot(options) {
        JsonApiModule_1.connectionName =
            options.connectionName || JsonApiModule_1.connectionName;
        options.connectionName = JsonApiModule_1.connectionName;
        options.options = {
            ...constants_1.ConfigParamDefault,
            ...options.options,
        };
        const commonModule = json_api_nestjs_common_module_1.JsonApiNestJsCommonModule.forRoot(options);
        const entityImport = options.entities.map((entity) => {
            const controller = (options.controllers || []).find((item) => item &&
                Reflect.getMetadata(constants_2.JSON_API_DECORATOR_ENTITY, item) === entity);
            const module = mixin_1.BaseModuleClass.forRoot({
                entity,
                connectionName: JsonApiModule_1.connectionName,
                controller,
                config: {
                    ...constants_1.ConfigParamDefault,
                    ...options.options,
                },
            });
            module.imports = [
                core_1.DiscoveryModule,
                commonModule,
                ...(module.imports || []),
            ];
            return module;
        });
        const operationModuleImport = options.options?.operationUrl
            ? [
                atomic_operation_module_1.AtomicOperationModule.forRoot({
                    ...options,
                    connectionName: JsonApiModule_1.connectionName,
                }, entityImport, commonModule),
                core_1.RouterModule.register([
                    {
                        module: atomic_operation_module_1.AtomicOperationModule,
                        path: options.options.operationUrl,
                    },
                ]),
            ]
            : [];
        return {
            module: JsonApiModule_1,
            imports: [...operationModuleImport, ...entityImport],
        };
    }
};
exports.JsonApiModule = JsonApiModule;
exports.JsonApiModule = JsonApiModule = JsonApiModule_1 = tslib_1.__decorate([
    (0, common_1.Module)({})
], JsonApiModule);
//# sourceMappingURL=json-api.module.js.map