"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogTimeInterceptors = void 0;
const rxjs_1 = require("rxjs");
class LogTimeInterceptors {
    intercept(context, next) {
        const now = Date.now();
        return next.handle().pipe((0, rxjs_1.map)((r) => {
            const response = context.switchToHttp().getResponse();
            const time = Date.now() - now;
            response.setHeader('x-response-time', time);
            if (r && r.meta) {
                r.meta['time'] = time;
            }
            return r;
        }));
    }
}
exports.LogTimeInterceptors = LogTimeInterceptors;
//# sourceMappingURL=log-time.interceptors.js.map