"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CheckItemEntityPipe = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const typeorm_1 = require("typeorm");
const constants_1 = require("../../../constants");
const typeorm_utils_service_1 = require("../../service/typeorm-utils.service");
class CheckItemEntityPipe {
    repository;
    typeormUtilsService;
    async transform(value) {
        const params = 'params';
        const result = await this.repository
            .createQueryBuilder(this.typeormUtilsService.currentAlias)
            .where(`${this.typeormUtilsService.getAliasPath(this.typeormUtilsService.currentPrimaryColumn)} = :${params}`)
            .setParameters({
            [params]: value,
        })
            .getOne();
        if (!result) {
            const error = {
                code: 'invalid_arguments',
                message: `Resource '${this.typeormUtilsService.currentAlias}' with id '${value}' does not exist`,
                path: [],
            };
            throw new common_1.NotFoundException([error]);
        }
        return value;
    }
}
exports.CheckItemEntityPipe = CheckItemEntityPipe;
tslib_1.__decorate([
    (0, common_1.Inject)(constants_1.CURRENT_ENTITY_REPOSITORY),
    tslib_1.__metadata("design:type", typeorm_1.Repository)
], CheckItemEntityPipe.prototype, "repository", void 0);
tslib_1.__decorate([
    (0, common_1.Inject)(typeorm_utils_service_1.TypeormUtilsService),
    tslib_1.__metadata("design:type", typeorm_utils_service_1.TypeormUtilsService)
], CheckItemEntityPipe.prototype, "typeormUtilsService", void 0);
//# sourceMappingURL=check-item-entity.pipe.js.map