"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ParseRelationshipNamePipe = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const typeorm_utils_service_1 = require("../../service/typeorm-utils.service");
class ParseRelationshipNamePipe {
    typeormUtilsService;
    transform(value) {
        this.checkRelName(value);
        return value;
    }
    checkRelName(value) {
        if (!this.typeormUtilsService.relationFields.find((i) => i === value)) {
            const error = {
                code: 'invalid_arguments',
                message: `Relation '${value}' does not exist in resource '${this.typeormUtilsService.currentAlias}'`,
                path: [],
            };
            throw new common_1.UnprocessableEntityException([error]);
        }
    }
}
exports.ParseRelationshipNamePipe = ParseRelationshipNamePipe;
tslib_1.__decorate([
    (0, common_1.Inject)(typeorm_utils_service_1.TypeormUtilsService),
    tslib_1.__metadata("design:type", typeorm_utils_service_1.TypeormUtilsService)
], ParseRelationshipNamePipe.prototype, "typeormUtilsService", void 0);
//# sourceMappingURL=parse-relationship-name.pipe.js.map