"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PostInputPipe = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const zod_1 = require("zod");
const zod_validation_error_1 = require("zod-validation-error");
const constants_1 = require("../../../constants");
class PostInputPipe {
    zodInputPostSchema;
    transform(value) {
        try {
            return this.zodInputPostSchema.parse(value, {
                errorMap: zod_validation_error_1.errorMap,
            })['data'];
        }
        catch (e) {
            if (e instanceof zod_1.ZodError) {
                throw new common_1.BadRequestException(e.issues);
            }
            throw new common_1.InternalServerErrorException(e);
        }
    }
}
exports.PostInputPipe = PostInputPipe;
tslib_1.__decorate([
    (0, common_1.Inject)(constants_1.ZOD_POST_SCHEMA),
    tslib_1.__metadata("design:type", Object)
], PostInputPipe.prototype, "zodInputPostSchema", void 0);
//# sourceMappingURL=post-input.pipe.js.map