"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryInputPipe = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const zod_1 = require("zod");
const zod_validation_error_1 = require("zod-validation-error");
const constants_1 = require("../../../constants");
class QueryInputPipe {
    zodInputQuerySchema;
    transform(value) {
        try {
            return this.zodInputQuerySchema.parse(value, {
                errorMap: zod_validation_error_1.errorMap,
            });
        }
        catch (e) {
            if (e instanceof zod_1.ZodError) {
                throw new common_1.BadRequestException(e.issues);
            }
            throw new common_1.InternalServerErrorException(e);
        }
    }
}
exports.QueryInputPipe = QueryInputPipe;
tslib_1.__decorate([
    (0, common_1.Inject)(constants_1.ZOD_INPUT_QUERY_SCHEMA),
    tslib_1.__metadata("design:type", Object)
], QueryInputPipe.prototype, "zodInputQuerySchema", void 0);
//# sourceMappingURL=query-input.pipe.js.map