import { Data, Entity, EntityRelation, MainData, Relationships, ResourceData } from '../../types';
import { ResourceObject } from '../../types/response';
export declare class TransformDataService<E extends Entity> {
    private applicationConfig;
    private entityPropsMapService;
    private _urlPath;
    get urlPath(): string[];
    private getLink;
    transformData(data: E): Pick<ResourceObject<E>, 'data' | 'included'>;
    transformData(data: E[]): Pick<ResourceObject<E, 'array'>, 'data' | 'included'>;
    getMainData(data: E): ResourceData<E> | null;
    getRelationships<Rel extends EntityRelation<E>>(data: E, rel: Rel): Data<E[Rel], Rel>;
    transformRelationshipsData(data: E): Relationships<E>;
    getData<T = string>(type: T, id: number | string): MainData<T>;
}
