"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Comments = exports.CommentKind = void 0;
const tslib_1 = require("tslib");
const typeorm_1 = require("typeorm");
var CommentKind;
(function (CommentKind) {
    CommentKind["Comment"] = "COMMENT";
    CommentKind["Message"] = "MESSAGE";
    CommentKind["Note"] = "NOTE";
})(CommentKind || (exports.CommentKind = CommentKind = {}));
const index_1 = require("./index");
let Comments = class Comments {
    id;
    text;
    kind;
    createdAt;
    updatedAt;
    createdBy;
};
exports.Comments = Comments;
tslib_1.__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    tslib_1.__metadata("design:type", Number)
], Comments.prototype, "id", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        type: 'text',
        nullable: false,
    }),
    tslib_1.__metadata("design:type", String)
], Comments.prototype, "text", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        type: 'enum',
        enum: CommentKind,
        nullable: false,
    }),
    tslib_1.__metadata("design:type", String)
], Comments.prototype, "kind", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        name: 'created_at',
        type: 'timestamp',
        nullable: true,
        default: 'CURRENT_TIMESTAMP',
    }),
    tslib_1.__metadata("design:type", Date)
], Comments.prototype, "createdAt", void 0);
tslib_1.__decorate([
    (0, typeorm_1.UpdateDateColumn)({
        name: 'updated_at',
        type: 'timestamp',
        nullable: true,
        default: 'CURRENT_TIMESTAMP',
    }),
    tslib_1.__metadata("design:type", Date)
], Comments.prototype, "updatedAt", void 0);
tslib_1.__decorate([
    (0, typeorm_1.ManyToOne)(() => index_1.Users, (item) => item.id),
    (0, typeorm_1.JoinColumn)({
        name: 'created_by',
    }),
    tslib_1.__metadata("design:type", Object)
], Comments.prototype, "createdBy", void 0);
exports.Comments = Comments = tslib_1.__decorate([
    (0, typeorm_1.Entity)('comments')
], Comments);
//# sourceMappingURL=comments.js.map