"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Roles = void 0;
const tslib_1 = require("tslib");
const typeorm_1 = require("typeorm");
const index_1 = require("./index");
let Roles = class Roles {
    id;
    name;
    key;
    isDefault;
    createdAt;
    updatedAt;
    users;
};
exports.Roles = Roles;
tslib_1.__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    tslib_1.__metadata("design:type", Number)
], Roles.prototype, "id", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        type: 'varchar',
        length: 128,
        nullable: true,
        default: 'NULL',
    }),
    tslib_1.__metadata("design:type", String)
], Roles.prototype, "name", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        type: 'varchar',
        length: 128,
        nullable: false,
        unique: true,
    }),
    tslib_1.__metadata("design:type", String)
], Roles.prototype, "key", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        name: 'is_default',
        type: 'boolean',
        default: 'false',
    }),
    tslib_1.__metadata("design:type", Boolean)
], Roles.prototype, "isDefault", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        name: 'created_at',
        type: 'timestamp',
        nullable: true,
        default: 'CURRENT_TIMESTAMP',
    }),
    tslib_1.__metadata("design:type", Date)
], Roles.prototype, "createdAt", void 0);
tslib_1.__decorate([
    (0, typeorm_1.UpdateDateColumn)({
        name: 'updated_at',
        type: 'timestamp',
        nullable: true,
        default: 'CURRENT_TIMESTAMP',
    }),
    tslib_1.__metadata("design:type", Date)
], Roles.prototype, "updatedAt", void 0);
tslib_1.__decorate([
    (0, typeorm_1.ManyToMany)(() => index_1.Users, (item) => item.roles),
    tslib_1.__metadata("design:type", Array)
], Roles.prototype, "users", void 0);
exports.Roles = Roles = tslib_1.__decorate([
    (0, typeorm_1.Entity)('roles')
], Roles);
//# sourceMappingURL=roles.js.map