"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Users = void 0;
const tslib_1 = require("tslib");
const typeorm_1 = require("typeorm");
const index_1 = require("./index");
let Users = class Users {
    id;
    login;
    firstName;
    testReal;
    testArrayNull;
    lastName;
    isActive;
    createdAt;
    testDate;
    updatedAt;
    addresses;
    manager;
    roles;
    comments;
    notes;
    userGroup;
};
exports.Users = Users;
tslib_1.__decorate([
    (0, typeorm_1.PrimaryGeneratedColumn)(),
    tslib_1.__metadata("design:type", Number)
], Users.prototype, "id", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        type: 'varchar',
        length: 100,
        nullable: false,
        unique: true,
    }),
    tslib_1.__metadata("design:type", String)
], Users.prototype, "login", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        name: 'first_name',
        type: 'varchar',
        length: 100,
        nullable: true,
        default: 'NULL',
    }),
    tslib_1.__metadata("design:type", String)
], Users.prototype, "firstName", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        name: 'test_real',
        type: 'real',
        array: true,
    }),
    tslib_1.__metadata("design:type", Array)
], Users.prototype, "testReal", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        name: 'test_array_null',
        type: 'real',
        array: true,
        nullable: true,
    }),
    tslib_1.__metadata("design:type", Array)
], Users.prototype, "testArrayNull", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        name: 'last_name',
        type: 'varchar',
        length: 100,
        nullable: true,
        default: 'NULL',
    }),
    tslib_1.__metadata("design:type", String)
], Users.prototype, "lastName", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        name: 'is_active',
        type: 'boolean',
        width: 1,
        nullable: true,
        default: false,
    }),
    tslib_1.__metadata("design:type", Boolean)
], Users.prototype, "isActive", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        name: 'created_at',
        type: 'timestamp',
        nullable: true,
        default: 'CURRENT_TIMESTAMP',
    }),
    tslib_1.__metadata("design:type", Date)
], Users.prototype, "createdAt", void 0);
tslib_1.__decorate([
    (0, typeorm_1.Column)({
        name: 'test_date',
        type: 'timestamp',
        nullable: true,
        default: 'CURRENT_TIMESTAMP',
    }),
    tslib_1.__metadata("design:type", Date)
], Users.prototype, "testDate", void 0);
tslib_1.__decorate([
    (0, typeorm_1.UpdateDateColumn)({
        name: 'updated_at',
        type: 'timestamp',
        nullable: true,
        default: 'CURRENT_TIMESTAMP',
    }),
    tslib_1.__metadata("design:type", Date)
], Users.prototype, "updatedAt", void 0);
tslib_1.__decorate([
    (0, typeorm_1.OneToOne)(() => index_1.Addresses, (item) => item.id),
    (0, typeorm_1.JoinColumn)({
        name: 'addresses_id',
    }),
    tslib_1.__metadata("design:type", index_1.Addresses)
], Users.prototype, "addresses", void 0);
tslib_1.__decorate([
    (0, typeorm_1.OneToOne)(() => Users, (item) => item.id),
    (0, typeorm_1.JoinColumn)({
        name: 'manager_id',
    }),
    tslib_1.__metadata("design:type", Users)
], Users.prototype, "manager", void 0);
tslib_1.__decorate([
    (0, typeorm_1.ManyToMany)(() => index_1.Roles, (item) => item.users),
    (0, typeorm_1.JoinTable)({
        name: 'users_have_roles',
        inverseJoinColumn: {
            referencedColumnName: 'id',
            name: 'role_id',
        },
        joinColumn: {
            referencedColumnName: 'id',
            name: 'user_id',
        },
    }),
    tslib_1.__metadata("design:type", Array)
], Users.prototype, "roles", void 0);
tslib_1.__decorate([
    (0, typeorm_1.OneToMany)(() => index_1.Comments, (item) => item.createdBy),
    tslib_1.__metadata("design:type", Array)
], Users.prototype, "comments", void 0);
tslib_1.__decorate([
    (0, typeorm_1.OneToMany)(() => index_1.Notes, (item) => item.createdBy),
    tslib_1.__metadata("design:type", Array)
], Users.prototype, "notes", void 0);
tslib_1.__decorate([
    (0, typeorm_1.ManyToOne)(() => index_1.UserGroups, (userGroup) => userGroup.id),
    (0, typeorm_1.JoinColumn)({ name: 'user_groups_id' }),
    tslib_1.__metadata("design:type", index_1.UserGroups)
], Users.prototype, "userGroup", void 0);
exports.Users = Users = tslib_1.__decorate([
    (0, typeorm_1.Entity)('users')
], Users);
//# sourceMappingURL=users.js.map