"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.entities = void 0;
exports.createAndPullSchemaBase = createAndPullSchemaBase;
exports.mockDBTestModule = mockDBTestModule;
const tslib_1 = require("tslib");
const typeorm_1 = require("@nestjs/typeorm");
const pg_mem_1 = require("pg-mem");
const fs_1 = require("fs");
const path_1 = require("path");
const entities_1 = require("./entities");
const uuid_1 = require("uuid");
tslib_1.__exportStar(require("./entities"), exports);
tslib_1.__exportStar(require("./utils"), exports);
exports.entities = [
    entities_1.Users,
    entities_1.UserGroups,
    entities_1.Roles,
    entities_1.RequestsHavePodLocks,
    entities_1.Requests,
    entities_1.Pods,
    entities_1.Comments,
    entities_1.Addresses,
    entities_1.Notes,
];
function createAndPullSchemaBase() {
    const dump = (0, fs_1.readFileSync)((0, path_1.join)(__dirname, 'db-for-test'), {
        encoding: 'utf8',
    });
    const db = (0, pg_mem_1.newDb)({
        autoCreateForeignKeyIndices: true,
    });
    db.public.registerFunction({
        name: 'current_database',
        implementation: () => 'test',
    });
    db.public.registerFunction({
        name: 'version',
        implementation: () => 'PostgreSQL 12.5 on x86_64-pc-linux-musl, compiled by gcc (Alpine 10.2.1_pre1) 10.2.1 20201203, 64-bit',
    });
    db.registerExtension('uuid-ossp', (schema) => {
        schema.registerFunction({
            name: 'uuid_generate_v4',
            returns: pg_mem_1.DataType.uuid,
            implementation: uuid_1.v4,
            impure: true,
        });
    });
    db.public.none(dump);
    return db;
}
function mockDBTestModule(db) {
    return typeorm_1.TypeOrmModule.forRootAsync({
        useFactory() {
            return {
                type: 'postgres',
                // logging: true,
                entities: [
                    entities_1.Users,
                    entities_1.UserGroups,
                    entities_1.Roles,
                    entities_1.RequestsHavePodLocks,
                    entities_1.Requests,
                    entities_1.Pods,
                    entities_1.Comments,
                    entities_1.Addresses,
                    entities_1.Notes,
                ],
            };
        },
        async dataSourceFactory(options) {
            const dataSource = await db.adapters.createTypeormDataSource(options);
            return dataSource;
        },
    });
}
//# sourceMappingURL=index.js.map