"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.providerEntities = providerEntities;
exports.getRepository = getRepository;
const typeorm_1 = require("@nestjs/typeorm");
const entities_1 = require("../entities");
const entities_2 = require("../entities");
const constants_1 = require("../../constants");
function providerEntities(dataSourceToken) {
    return entities_1.Entities.map((entitiy) => {
        return {
            provide: (0, typeorm_1.getRepositoryToken)(entitiy, constants_1.DEFAULT_CONNECTION_NAME),
            useFactory(dataSource) {
                return dataSource.getRepository(entitiy);
            },
            inject: [(0, typeorm_1.getDataSourceToken)()],
        };
    });
}
function getRepository(module) {
    const userRepository = module.get((0, typeorm_1.getRepositoryToken)(entities_2.Users, constants_1.DEFAULT_CONNECTION_NAME));
    const addressesRepository = module.get((0, typeorm_1.getRepositoryToken)(entities_1.Addresses, constants_1.DEFAULT_CONNECTION_NAME));
    const notesRepository = module.get((0, typeorm_1.getRepositoryToken)(entities_1.Notes, constants_1.DEFAULT_CONNECTION_NAME));
    const commentsRepository = module.get((0, typeorm_1.getRepositoryToken)(entities_1.Comments, constants_1.DEFAULT_CONNECTION_NAME));
    const rolesRepository = module.get((0, typeorm_1.getRepositoryToken)(entities_1.Roles, constants_1.DEFAULT_CONNECTION_NAME));
    const userGroupRepository = module.get((0, typeorm_1.getRepositoryToken)(entities_1.UserGroups, constants_1.DEFAULT_CONNECTION_NAME));
    const podsRepository = module.get((0, typeorm_1.getRepositoryToken)(entities_1.Pods, constants_1.DEFAULT_CONNECTION_NAME));
    return {
        userRepository,
        addressesRepository,
        notesRepository,
        commentsRepository,
        rolesRepository,
        userGroupRepository,
        podsRepository,
    };
}
//# sourceMappingURL=provider-entities.js.map