"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MapControllerEntity = MapControllerEntity;
const constants_1 = require("../constants");
function MapControllerEntity(entities, entityModules) {
    const mapController = entities.reduce((acum, entity, index) => {
        const entityModule = entityModules[index];
        if (entityModule.controllers) {
            const controller = entityModule.controllers.at(0);
            if (controller)
                acum.set(entity, controller);
        }
        return acum;
    }, new Map());
    return {
        provide: constants_1.MAP_CONTROLLER_ENTITY,
        useValue: mapController,
    };
}
//# sourceMappingURL=map-controller-entity.js.map