import { Entity, FilterOperand } from '../types';
import { QueryField, TypeInputProps } from '../helper/zod';
type OutPutFilter = {
    relation: null | Record<string, Record<string, Partial<{
        [key in FilterOperand]: string | string[];
    }>>>;
    target: null | Record<string, Partial<{
        [key in FilterOperand]: string | string[];
    }>>;
};
export declare class TransformInputService<E extends Entity> {
    transformSort(data: TypeInputProps<E, QueryField.sort>): Record<string, Record<string, string>> | null;
    transformInclude(data: TypeInputProps<E, QueryField.include>): string[] | null;
    transformFields<E extends Entity>(data: TypeInputProps<E, QueryField.fields>): Record<string, string[]> | null;
    transformFilter<E extends Entity>(data: TypeInputProps<E, QueryField.filter>): OutPutFilter | null;
}
export {};
