"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OperandsMapExpressionForNullRelation = exports.OperandMapExpressionForNull = exports.OperandsMapExpression = exports.EXPRESSION = exports.FilterOperand = void 0;
const json_shared_type_1 = require("../../../json-shared-type/src");
Object.defineProperty(exports, "FilterOperand", { enumerable: true, get: function () { return json_shared_type_1.FilterOperand; } });
exports.EXPRESSION = 'EXPRESSION';
exports.OperandsMapExpression = {
    [json_shared_type_1.FilterOperand.eq]: `= :${exports.EXPRESSION}`,
    [json_shared_type_1.FilterOperand.ne]: `<> :${exports.EXPRESSION}`,
    [json_shared_type_1.FilterOperand.regexp]: `~* :${exports.EXPRESSION}`,
    [json_shared_type_1.FilterOperand.gt]: `> :${exports.EXPRESSION}`,
    [json_shared_type_1.FilterOperand.gte]: `>= :${exports.EXPRESSION}`,
    [json_shared_type_1.FilterOperand.in]: `IN (:...${exports.EXPRESSION})`,
    [json_shared_type_1.FilterOperand.like]: `ILIKE :${exports.EXPRESSION}`,
    [json_shared_type_1.FilterOperand.lt]: `< :${exports.EXPRESSION}`,
    [json_shared_type_1.FilterOperand.lte]: `<= :${exports.EXPRESSION}`,
    [json_shared_type_1.FilterOperand.nin]: `NOT IN (:...${exports.EXPRESSION})`,
    [json_shared_type_1.FilterOperand.some]: `&& :${exports.EXPRESSION}`,
};
exports.OperandMapExpressionForNull = {
    [json_shared_type_1.FilterOperand.ne]: 'IS NOT NULL',
    [json_shared_type_1.FilterOperand.eq]: 'IS NULL',
};
exports.OperandsMapExpressionForNullRelation = {
    [json_shared_type_1.FilterOperand.ne]: `EXISTS ${exports.EXPRESSION}`,
    [json_shared_type_1.FilterOperand.eq]: `NOT EXISTS ${exports.EXPRESSION}`,
};
//# sourceMappingURL=operand.js.map